<!DOCTYPE html>
<meta charset="utf-8">
<link rel="stylesheet" href="https://unpkg.com/purecss@2.0.0/build/pure-min.css">
<style>
	body{
		margin: 0;
		padding: 0;
    background-color: rgb(245,245,245);
    font-family: Helvetica;

	}
	#mainsvg{
		width: 100%;
		height: 100vh;
		position: absolute;
		margin: 0;
		padding: 0;
		box-sizing: border-box;
	}
	#sidebar{
		position: absolute;
    right: 10px;
    top: 10px;
    bottom: 10px;
    width: 340px;
    height: 100%;
    background-color: rgb(60,60,60);
    padding: 20px;
    box-sizing: border-box;
    border-radius: 20px;

	}



    .active,.clicked {
        stroke: rgb(100,100,100);
        stroke-width: 3px;
    }


.active text,.clicked text {
  stroke-width:0;
}

.shapetext{
  font-size: 12px;

}


.object .circle{

}




</style>
<body>
    <script src="https://d3js.org/d3.v4.min.js"></script>
    <svg id='mainsvg'></svg>

    <div id="sidebar">
		<button id="addCircle">Add circle</button>
		<button id="removeCircle">Remove circle</button>
	</div>
    
    <script>
   var data = [
    {name: "Hank", points: 1110100, x:100, y:100},
    {name: "Steve", points: 1064500, x:300, y:100},
    {name: "Billy", points: 1050200,x:500, y:100},
    ];
    var svg = d3.select("svg")
    			.call(d3.zoom().on("zoom", function () {
              			svg.attr("transform", d3.event.transform)
      					}).scaleExtent([0.1, 10]))
    			.append('g')
      			,
    width = document.body.clientWidth,
    height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight,
    radius = 100;


    var color = d3.scaleOrdinal()
        .range(d3.schemeCategory20);


const circleRadius = 120;
const circleDiameter = circleRadius * 2;


const plot = (data, svg) => {



  const object = svg
    .selectAll('.object')
    .data(data)
    


  var obj = object
  .enter()
    .append('g')
    .attr("class", "object")

    .attr("transform", function(d){
    return "translate(" + [ d.x,d.y ] + ")"
  })
    .call(drag_this)
    .on("mouseover", function (d) {
      d3.select(this).style("cursor", "move");})
    .on("mouseout", function (d) {})
    .on("click", function (d, i) { 
        if (d3.event.defaultPrevented) return; // dragged
        d3.selectAll('g').classed("clicked", false);
          d3.select(this).classed("clicked", !d3.select(this).classed("clicked"));
              })
   
    obj.append('circle')
    // .attr('cy', circleRadius)
    // .attr('cx', (d, i) => circleRadius + (i * circleDiameter))
    .attr("class", "circle")
    .attr('r', circleRadius)
    .style("fill", function (d, i) { return color(i); });

     obj.append("rect")
        .attr('width', circleDiameter)
        .attr('height', circleDiameter)
        .attr("class", "rect")
        .style("fill", function (d, i) { return color(i); })
        .attr("transform", "translate("+circleRadius+", -"+circleRadius+")");

     obj.append("text")
        .text("expected input")
        .attr("class", "shapetext")
        .attr("transform", "translate(-50, -90)");


     obj.append("text")
        .text("response")
        .attr("class", "shapetext")
        .attr("transform", "translate(200, -90)"); 

    obj.append("text")
        .attr("class", "shapetext")
        .attr("transform", "translate(0, 0)")
        .text(function(d, i) {
          return d.name
        });


     object
    .exit()
    .remove();

  
};

var drag_this = d3.drag().subject(this)
.on('drag',function(d){

	console.log(d);
       
  d.x += d3.event.dx;
  d.y += d3.event.dy;

  d3.select(this).attr("transform", function(d,i){
    return "translate(" + [ d.x,d.y ] + ")"
  });

    });


const addCircle = () => {
  data.push( {name: "new", points: 1050200, x:200, y:500} );
  plot(data, svg);
};

const removeCircle = () => {
  data.pop();
  plot(data, svg);
};

document.getElementById('addCircle').addEventListener('click', addCircle);
document.getElementById('removeCircle').addEventListener('click', removeCircle);

plot(data, svg);

        

    </script>
</body>
